View Issue Details

IDProjectCategoryView StatusLast Update
0003394GNUnetutil librarypublic2018-06-07 00:25
ReporterSree Harsha TotakuraAssigned ToChristian Grothoff 
PrioritynormalSeveritymajorReproducibilityrandom
Status closedResolutionfixed 
Product Version0.10.1 
Target Version0.11.0pre66Fixed in Version0.11.0pre66 
Summary0003394: test_server testcase fails with a crash
DescriptionLooks like the state machine in the test case is not strictly followed.
Additional Informationcore.5197
bash-4.3# gdb .libs/test_server
GNU gdb (GDB) 7.7
Copyright (C) 2014 Free Software Foundation, Inc.
License GPLv3+: GNU GPL version 3 or later <http://gnu.org/licenses/gpl.html>
This is free software: you are free to change and redistribute it.
There is NO WARRANTY, to the extent permitted by law. Type "show copying"
and "show warranty" for details.
This GDB was configured as "x86_64-unknown-linux-gnu".
Type "show configuration" for configuration details.
For bug reporting instructions, please see:
<http://www.gnu.org/software/gdb/bugs/>.
Find the GDB manual and other documentation resources online at:
<http://www.gnu.org/software/gdb/documentation/>.
For help, type "help".
Type "apropos word" to search for commands related to "word"...
Reading symbols from .libs/test_server...done.
(gdb) core core.5197
[New LWP 5197]
warning: Could not load shared library symbols for linux-vdso.so.1.
Do you need "set solib-search-path" or "set sysroot"?
Core was generated by `/tmp/nix-build-gnunet-0.10.1.drv-0/gnunet-0.10.1/src/util/.libs/test_server'.
Program terminated with signal SIGABRT, Aborted.
#0 0x00007f55d5504409 in raise ()
   from /gnu/store/hf5kklv837xbfcv6gc7gpsj36l69j3sj-glibc-2.19/lib/libc.so.6
(gdb) bt
#0 0x00007f55d5504409 in raise ()
   from /gnu/store/hf5kklv837xbfcv6gc7gpsj36l69j3sj-glibc-2.19/lib/libc.so.6
#1 0x00007f55d5505808 in abort ()
   from /gnu/store/hf5kklv837xbfcv6gc7gpsj36l69j3sj-glibc-2.19/lib/libc.so.6
#2 0x00007f55d5da4659 in GNUNET_abort () at common_logging.c:289
#3 0x0000000000401aa7 in first_reply_handler (cls=<optimized out>, msg=<optimized out>)
    at test_server.c:70
#4 0x00007f55d5da8558 in receive_ready (cls=0x24250e0, tc=<optimized out>)
    at connection.c:1064
#5 0x00007f55d5dcd70c in run_ready (ws=0x2424830, rs=0x24247a0) at scheduler.c:595
#6 GNUNET_SCHEDULER_run (task=task@entry=0x401290 <task>,
    task_cls=task_cls@entry=0x602470 <ok>) at scheduler.c:817
#7 0x000000000040105e in main (argc=<optimized out>, argv=<optimized out>)
    at test_server.c:197
(gdb) select-frame 4
(gdb) p ok
$1 = 2
(gdb) q
TagsNo tags attached.

Activities

Sree Harsha Totakura

2014-05-05 15:42

developer   ~0008280

Not entirely a state machine's fault; the receive callback does not check error conditions. The connection is being reset for some reason.

bash-4.3# gdb .libs/test_server
GNU gdb (GDB) 7.7
Copyright (C) 2014 Free Software Foundation, Inc.
License GPLv3+: GNU GPL version 3 or later <http://gnu.org/licenses/gpl.html>
This is free software: you are free to change and redistribute it.
There is NO WARRANTY, to the extent permitted by law. Type "show copying"
and "show warranty" for details.
This GDB was configured as "x86_64-unknown-linux-gnu".
Type "show configuration" for configuration details.
For bug reporting instructions, please see:
<http://www.gnu.org/software/gdb/bugs/>.
Find the GDB manual and other documentation resources online at:
<http://www.gnu.org/software/gdb/documentation/>.
For help, type "help".
Type "apropos word" to search for commands related to "word"...
Reading symbols from .libs/test_server...done.
(gdb) core core.5202
[New LWP 5202]
warning: Could not load shared library symbols for linux-vdso.so.1.
Do you need "set solib-search-path" or "set sysroot"?
Core was generated by `/tmp/nix-build-gnunet-0.10.1.drv-0/gnunet-0.10.1/src/util/.libs/test_server'.
Program terminated with signal SIGABRT, Aborted.
#0 0x00007fe6593dd409 in raise ()
   from /gnu/store/hf5kklv837xbfcv6gc7gpsj36l69j3sj-glibc-2.19/lib/libc.so.6
(gdb) bt
#0 0x00007fe6593dd409 in raise ()
   from /gnu/store/hf5kklv837xbfcv6gc7gpsj36l69j3sj-glibc-2.19/lib/libc.so.6
#1 0x00007fe6593de808 in abort ()
   from /gnu/store/hf5kklv837xbfcv6gc7gpsj36l69j3sj-glibc-2.19/lib/libc.so.6
#2 0x00007fe659c7e189 in GNUNET_abort () at common_logging.c:289
#3 0x00000000004014d3 in first_reply_handler (cls=0x0, msg=0x0) at test_server.c:70
#4 0x00007fe659c7aef6 in receive_helper (cls=0x1ce22c0, buf=0x0, available=0,
    addr=0x1ce23f0, addrlen=16, errCode=104) at client.c:529
#5 0x00007fe659c8389d in signal_receive_error (connection=0x1ce20e0, errcode=104)
    at connection.c:482
#6 0x00007fe659c86811 in receive_ready (cls=0x1ce20e0, tc=0x7fffd53e9490)
    at connection.c:1064
#7 0x00007fe659cb2517 in run_ready (rs=0x1ce17a0, ws=0x1ce1830) at scheduler.c:595
#8 0x00007fe659cb2d29 in GNUNET_SCHEDULER_run (task=0x401d06 <task>,
    task_cls=0x6028b0 <ok>) at scheduler.c:817
#9 0x0000000000402086 in main (argc=1, argv=0x7fffd53e96a8) at test_server.c:197
(gdb)

Christian Grothoff

2014-05-11 14:04

manager   ~0008317

Fixed in SVN 33236.

Issue History

Date Modified Username Field Change
2014-05-05 15:22 Sree Harsha Totakura New Issue
2014-05-05 15:42 Sree Harsha Totakura Note Added: 0008280
2014-05-08 09:47 Christian Grothoff Severity minor => major
2014-05-08 09:47 Christian Grothoff Target Version SVN HEAD => 0.11.0pre66
2014-05-11 14:04 Christian Grothoff Note Added: 0008317
2014-05-11 14:04 Christian Grothoff Status new => resolved
2014-05-11 14:04 Christian Grothoff Fixed in Version => 0.11.0pre66
2014-05-11 14:04 Christian Grothoff Resolution open => fixed
2014-05-11 14:04 Christian Grothoff Assigned To => Christian Grothoff
2018-06-07 00:25 Christian Grothoff Status resolved => closed